<template>
  <AppTable
    class="tablePopular"
    :class="{ '_no-city': !location.id }"
    :table-headings="headings"
    :grid="grid">
    <!-- картинка -->
    <template
      :slot="`unit-${headings[0].name}`"
      slot-scope="{ part }">
      <div class="picture">
        <img
          v-if="part.img"
          :src="part.img"
          :alt="part.brand">
        <img
          v-else
          svg-inline
          src="~/assets/svg/redesign/navigation-parts.svg">
      </div>
    </template>

    <!-- название производителя -->
    <template
      :slot="`unit-${headings[1].name}`"
      slot-scope="{ part }">
      <span class="__hide-shadow __no-wrap">{{ part.brand }}</span>
      <span class="valueIsMobile">{{ part.vendorCode }}</span>
    </template>

    <!-- номер запчасти -->
    <template
      :slot="`unit-${headings[2].name}`"
      slot-scope="{ part }">
      <flink
        :href="href4Item(part)"
        domain="main"
        target="_blank"
        class="link __hide-shadow __no-wrap">
        {{ part.vendorCode }}
      </flink>
    </template>

    <!-- название запчасти -->
    <template
      :slot="`unit-${headings[3].name}`"
      slot-scope="{ part }">
      {{ part.partName }}
    </template>

    <!-- дата последнего запроса -->
    <div
      :slot="`unit-${headings[4].name}`"
      slot-scope="{ part }"
      class="__gray">
      <span class="td-updated">
        {{ part.createdAt | dateFormat({ nouns: true }) | capitalize }}
        <span class="valueIsMobile">{{ location.id ? `в ${location.prepositionalName}` : 'во всех странах' }}</span>
      </span>
      <!-- <span class="td-requests">Запросов за сутки 1000</span> -->
    </div>

    <!-- стоимость запчасти -->
    <template
      :slot="`unit-${headings[5].name}`"
      slot-scope="{ part }">
      <div>
        <span class="__no-wrap">{{ part.priceMin | spacifyNumber }} -</span>
        <span class="__no-wrap">{{ part.priceMax | spacifyNumber }} ₽</span>
      </div>
    </template>

    <!-- счетчик предложений в городе -->
    <template
      :slot="`unit-${headings[6].name}`"
      slot-scope="{ part }">
      <flink
        v-if="part.userLocationCount"
        :href="href4Item(part)"
        class="button buttonSellerCounter">
        {{ part.userLocationCount | spacifyNumber }}
        {{ part.userLocationCount | transChoose([ 'предложение', 'предложения', 'предложений', ]) }}
      </flink>
      <div
        v-else
        class="noResult">Нет предложений</div>
    </template>

    <!-- счетчик предложений на портале -->
    <template
      :slot="`unit-${headings[7].name}`"
      slot-scope="{ part }">
      <div class="valueIsMobile">Всего на портале</div>
      <flink
        :href="`${href4Item(part)}?location=0`"
        class="button buttonSellerCounter">
        {{ part.allOffersCount | spacifyNumber }}
        {{ part.allOffersCount | transChoose([ 'предложение', 'предложения', 'предложений', ]) }}
      </flink>
      <!-- <div class="td-analogs">Есть заменители</div> -->
    </template>
  </AppTable>
</template>

<script>
import { mapState } from 'vuex';

import mapFilters from '~/assets/js/helpers/map-filters';
import AppTable from '~/components/redesign/app-table/app-table';

export default {
  name: 'MainSearch',
  components: {
    AppTable,
  },
  props: {
    grid: {
      type: Object,
      default() { return { data: [] }; },
    },
  },
  computed: {
    ...mapState(['location']),
    headings() {
      return [
        {
          name: 'img',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'brand',
          title: 'Производитель',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'vendorCode',
          title: 'Номер',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'partName',
          title: 'Название',
          classes: '__all-wrap',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'createdAd',
          title: 'Дата последнего запроса',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'price',
          title: 'Стоимость',
          classes: '_align-right',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'sellerCounterLocal',
          title: `Предложения в ${this.location.prepositionalName}`,
          hidden: !this.location.id,
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'sellerCounterAll',
          title: 'Всего на сайте',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
      ];
    },
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    href4Item(item) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(item.brand));
      url.push(this.vendorCodeSlug(item.vendorCode));
      return url.join('/');
    },
  },
};
</script>
